<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                template="/layout/template.xhtml">

    <ui:define name="content">
        <h:panelGrid rendered="#{getPrincipal.loggedIn and getPrincipal.admin}">

            <div>
                <h1>Manage Template</h1>
            </div>

            <div class="card crud-demo">
                <h:form id="form">
                    <p:growl id="messages" showDetail="true"/>

                    <p:toolbar>
                        <p:toolbarGroup>
                            <p:commandButton value="New" icon="pi pi-plus" actionListener="#{templateBean.openNew()}"
                                             update=":dialogs:manage-template-content"
                                             oncomplete="PF('manageTemplateDialog').show()"
                                             styleClass="ui-button-success" style="margin-right: .5rem">
                                <p:resetInput target=":dialogs:manage-template-content"/>
                            </p:commandButton>
                        </p:toolbarGroup>

                    </p:toolbar>

                    <p:dataTable id="dt-templates" widgetVar="dtTemplate" var="template"
                                 value="#{templateBean.getAll()}"
                                 reflow="true" styleClass="templates-table"
                                 rowKey="#{template.getId()}" paginator="true" rows="10" rowSelectMode="add"
                                 paginatorPosition="bottom">


                        <p:column headerText="Id">
                            <h:outputText value="#{template.id}"/>
                        </p:column>
                        <p:column headerText="Title">
                            <h:outputText value="#{template.title}"/>
                        </p:column>
                        <p:column headerText="Is Enable">
                            <h:outputText value="#{template.enable}"/>
                        </p:column>

                        <p:column headerText="File Name">
                            <h:outputText value="#{template.fileName}"/>
                        </p:column>
                        <p:column headerText="Description">
                            <h:outputText value="#{template.description}"/>
                        </p:column>
                        <p:column exportable="false">
                            <p:commandButton icon="pi pi-pencil" update=":dialogs:manage-template-content"
                                             oncomplete="PF('manageTemplateDialog').show()"
                                             styleClass="edit-button rounded-button ui-button-success">
                                <f:setPropertyActionListener value="#{template}"
                                                             target="#{templateBean.selectedTemplate}"/>
                                <p:resetInput target=":dialogs:manage-template-content"/>
                            </p:commandButton>
                            <p:commandButton icon="pi pi-search" update=":dialogs:example-template-content"
                                             oncomplete="PF('TemplateExample').show()"
                                             styleClass="edit-button rounded-button ui-button-success">
                                <f:setPropertyActionListener value="#{template}"
                                                             target="#{templateBean.selectedTemplate}"/>
                                <p:resetInput target=":dialogs:example-template-content"/>
                            </p:commandButton>

                            <p:commandButton class="ui-button-warning rounded-button" icon="pi pi-trash"

                                             oncomplete="PF('deleteTemplateDialog').show()">
                                <f:setPropertyActionListener value="#{template}"
                                                             target="#{templateBean.selectedTemplate}"/>
                            </p:commandButton>
                        </p:column>

                    </p:dataTable>
                </h:form>

                <h:form id="dialogs" enctype="multipart/form-data">
                    <p:dialog header="Template Details" showEffect="fade" minimizable="true" maximizable="true"
                              modal="true"
                              widgetVar="manageTemplateDialog"
                              responsive="true">
                        <p:outputPanel id="manage-template-content" class="ui-fluid">
                            <p:outputPanel rendered="#{not empty templateBean.selectedTemplate}">
                                <div class="field">
                                    <p:outputLabel for="title">Template Title</p:outputLabel>
                                    <p:inputText id="title" value="#{templateBean.title}"
                                    />
                                </div>
                                <div class="field">
                                    <p:outputLabel for="description">Template Description</p:outputLabel>
                                    <p:inputTextarea id="description" value="#{templateBean.description}"
                                    />
                                </div>
                                <div class="field">
                                    <p:selectBooleanCheckbox id="enable" value="#{templateBean.enable}"
                                                             style="margin-right:5px;"/>
                                    <p:outputLabel for="enable">Enable Template</p:outputLabel>
                                </div>
                                <div class="field">


                                    <p:fileUpload value="#{templateBean.savedFile}" mode="simple" skinSimple="true"
                                                  sizeLimit="1000000" allowTypes="/(\.|\/)(mustache)$/"/>

                                </div>


                            </p:outputPanel>
                        </p:outputPanel>
                        <f:facet name="footer">
                            <p:commandButton value="Save" icon="pi pi-check"
                                             action="#{templateBean.insertUpdateSelectedTemplate}"
                                             update="manage-template-content"
                            />
                            <p:commandButton value="Cancel" icon="pi pi-times"
                                             onclick="PF('manageTemplateDialog').hide()"
                                             class="ui-button-secondary" type="button"/>
                        </f:facet>
                    </p:dialog>

                    <p:dialog header="Template Example" showEffect="fade" minimizable="true" maximizable="true"
                              modal="true"
                              widgetVar="TemplateExample"
                              responsive="true">
                        <p:outputPanel id="example-template-content" class="ui-fluid">
                            <p:outputPanel rendered="#{not empty templateBean.selectedTemplate}">
                                <div class="field">
                                    <p:outputLabel for="example-title">Template Title</p:outputLabel>
                                    <p:inputText id="example-title" value="#{templateBean.title}"
                                    />
                                </div>
                                <div class="field">
                                    <p:outputLabel for="content">Template Example</p:outputLabel>
                                    <p:inputTextarea id="content" value="#{templateBean.content}"/>
                                </div>
                            </p:outputPanel>
                        </p:outputPanel>
                    </p:dialog>

                    <p:confirmDialog widgetVar="deleteTemplateDialog" showEffect="fade" width="300"
                                     message="Delete the template?" header="Confirm" severity="warn">
                        <p:commandButton value="Yes" icon="pi pi-check"
                                         actionListener="#{templateBean.deleteTemplate}"
                                         oncomplete="PF('deleteTemplateDialog').hide()"
                                         update="@this"/>
                        <p:commandButton value="No" type="button" styleClass="ui-button-secondary" icon="pi pi-times"
                                         onclick="PF('deleteTemplateDialog').hide()"/>
                    </p:confirmDialog>

                    <p:confirmDialog global="true" showEffect="fade" width="300">
                        <p:commandButton value="Yes" type="button" styleClass="ui-confirmdialog-yes"
                                         icon="pi pi-check"/>
                        <p:commandButton value="No" type="button" styleClass="ui-confirmdialog-no ui-button-secondary"
                                         icon="pi pi-times"/>
                    </p:confirmDialog>
                </h:form>
            </div>
        </h:panelGrid>

        <h:panelGrid rendered="#{not getPrincipal.admin}">
            <h:panelGrid styleClass="gzl-mr-3rem gzl-ml-3rem gzl-align-center ">
                <h1 class="bold">Erreur 403</h1>
                <h2 class="bold">Accès interdit !</h2>
                <h:graphicImage
                        styleClass="center-block img-responsive gzl-splash-error gzl-mt-3rem gzl-mb-3rem mw-100"
                        name="resources/images/ihe.png" tooltip="IHE GAZELLE" tooltipPosition="left"/>
                <p><a class="btn btn-default btn-lg" href="/hl7v2-simulators">Retourner à l'accueil</a></p>
            </h:panelGrid>
        </h:panelGrid>
    </ui:define>
</ui:composition>
